<?php
namespace FM\Service;

use FM\Factory\CalendarioFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;

class CalendarioService {

    protected $CalendarioFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, CalendarioFactory $CalendarioFactory, Environment $Environment, NewCode $newCode) {
        $this->connection                = $entityManager->getConnection();
        $this->CalendarioFactory         = $CalendarioFactory;
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function getTarefasCalendario($parametros) {  
        // debugApi([$parametros]);      
        // "CDOPERADOR"        => $parametros['CDOPERADOR'],    
            $params = array(
                "PERIODOINICIAL"    => $parametros['PERIODOINICIAL'],
                "PERIODOFINAL"      => $parametros['PERIODOFINAL'],
                "NRLOCALCLIENTEPAI" => $parametros['NRLOCALCLIENTEPAI'],
                "NRLOCALCLIENTE"    => $parametros['NRLOCALCLIENTE'],
                "NRSETOR"           => $parametros['NRSETOR'],
                "NRATIVIDADE"       => $parametros['NRATIVIDADE'],
                "NRTIPOLOCALCLI"    => $parametros['NRTIPOLOCALCLI']
            );

            return $this->CalendarioFactory->getTarefasCalendario($params);
    }

    public function getLocaisCalendario($parametros) {
        // debugApi([$parametros]);
        $params = array(
            "IDTIPOLOCALCLI" => $parametros['IDTIPOLOCALCLI'],
        );

        return $this->CalendarioFactory->getLocaisCalendario($params);
    }

    public function getSetoresCalendario() {
        return $this->CalendarioFactory->getSetoresCalendario();
    }

    public function getAtividadesCalendario() {
        return $this->CalendarioFactory->getAtividadesCalendario();
    }

    public function getTipoDeLocal() {
        return $this->CalendarioFactory->getTipoDeLocal();
    }
    
}
