/* Tabela COMPENSACONTPAG: Compensao de Conta a Pagar */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela COMPENSACONTPAG */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela "Compensao de Conta a Pagar",
             utilizando a tabela Geral de Logs de Operaes
@C:\web_550\sql\end_conv\oracle\02AE_FINTRGO_LOG_FIN_COMPENSACONTPAG.sql;               */

CREATE OR REPLACE TRIGGER LOG_FIN_COMPENSACONTPAG
AFTER DELETE OR INSERT OR UPDATE
ON COMPENSACONTPAG FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);

BEGIN
   V_TIPO := '0';
   V_DESC := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'CdEmp=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.NRLANCCOMPPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' NroComp=' || :OLD.NRLANCCOMPPAG;
      END IF;

      IF (:OLD.CDFILIAL IS NOT NULL) AND (:OLD.NRLANBOLPAG IS NOT NULL) THEN
         V_DESC := V_DESC || ' ChaveBol=' || :OLD.CDFILIAL || :OLD.NRLANBOLPAG;
      END IF;

      IF :OLD.CDOPERLANCCOMCP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOpLanc=' || :OLD.CDOPERLANCCOMCP;
      END IF;

      IF :OLD.DTLANCCOMPPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' DtLancC=' || TO_CHAR(:OLD.DTLANCCOMPPAG, 'DD/MM/YYYY');
      END IF;

      IF :OLD.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' CdForn=' || :OLD.CDFORNECED;
      END IF;

      IF :OLD.DTCOMPENCTPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' DtCompPag=' || TO_CHAR(:OLD.DTCOMPENCTPAG, 'DD/MM/YYYY');
      END IF;

      IF :OLD.CDTPBAIXAREC IS NOT NULL THEN
         V_DESC := V_DESC || ' TpBxRec=' || :OLD.CDTPBAIXAREC;
      END IF;

      IF :OLD.CDTPBAIXAPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' TpBxPag=' || :OLD.CDTPBAIXAPAG;
      END IF;

      IF :OLD.CDAJUCTREC IS NOT NULL THEN
         V_DESC := V_DESC || ' TpAjRec=' ||  :OLD.CDAJUCTREC;
      END IF;

      IF :OLD.CDAJUCTPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' TpAjPag=' ||  :OLD.CDAJUCTPAG;
      END IF;

      IF :OLD.CDREDUCONT IS NOT NULL THEN
         V_DESC := V_DESC || ' CdReCont=' || :OLD.CDREDUCONT;
      END IF;

      IF :OLD.DTBAIXACOMP IS NOT NULL THEN
         V_DESC := V_DESC || ' DtBxComp=' || TO_CHAR(:OLD.DTBAIXACOMP, 'DD/MM/YYYY');
      END IF;

      IF (:OLD.CDFILIBAIXAREC IS NOT NULL) AND (:OLD.NRBAIXAREC IS NOT NULL) THEN
         V_DESC := V_DESC || ' ChavBxRec=' || :OLD.CDFILIBAIXAREC || :OLD.NRBAIXAREC;
      END IF;

      IF (:OLD.CDFILIBAIXAPAG IS NOT NULL) AND (:OLD.NRBAIXAPAG IS NOT NULL) THEN
         V_DESC := V_DESC || ' ChavBxPag=' || :OLD.CDFILIBAIXAPAG || :OLD.NRBAIXAPAG;
      END IF;

      IF :OLD.IDTPITUTLCOMPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' IdItem=' || :OLD.IDTPITUTLCOMPAG;
      END IF;
      IF :OLD.QTITENSCOMPPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' QtItens=' || TO_CHAR(:OLD.QTITENSCOMPPAG);
      END IF;

      IF :OLD.VRTOTALCOMPPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' VrComp=' || TO_CHAR(:OLD.VRTOTALCOMPPAG);
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDEMPRESA || :OLD.NRLANCCOMPPAG;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDEMPRESA,       '0') <> NVL(:NEW.CDEMPRESA,       '0')) OR
            (NVL(:OLD.NRLANCCOMPPAG,   '0') <> NVL(:NEW.NRLANCCOMPPAG,   '0')) OR
            (NVL(:OLD.CDFILIAL,        '0') <> NVL(:NEW.CDFILIAL,        '0')) OR
            (NVL(:OLD.NRLANBOLPAG,     '0') <> NVL(:NEW.NRLANBOLPAG,     '0')) OR
            (NVL(:OLD.CDOPERLANCCOMCP, '0') <> NVL(:NEW.CDOPERLANCCOMCP, '0')) OR
            (NVL(TO_CHAR(:OLD.DTLANCCOMPPAG, 'DD/MM/YYYY'),   '0') <> NVL(TO_CHAR(:NEW.DTLANCCOMPPAG, 'DD/MM/YYYY'),   '0')) OR
            (NVL(:OLD.CDFORNECED,      '0') <> NVL(:NEW.CDFORNECED,      '0')) OR
            (NVL(TO_CHAR(:OLD.DTCOMPENCTPAG, 'DD/MM/YYYY'),   '0') <> NVL(TO_CHAR(:NEW.DTCOMPENCTPAG, 'DD/MM/YYYY'),   '0')) OR
            (NVL(:OLD.CDTPBAIXAREC,    '0') <> NVL(:NEW.CDTPBAIXAREC,    '0')) OR
            (NVL(:OLD.CDTPBAIXAPAG,    '0') <> NVL(:NEW.CDTPBAIXAPAG,    '0')) OR
            (NVL(:OLD.CDAJUCTREC,      '0') <> NVL(:NEW.CDAJUCTREC,      '0')) OR
            (NVL(:OLD.CDAJUCTPAG,      '0') <> NVL(:NEW.CDAJUCTPAG,      '0')) OR
            (NVL(:OLD.CDREDUCONT,      '0') <> NVL(:NEW.CDREDUCONT,      '0')) OR
            (NVL(TO_CHAR(:OLD.DTBAIXACOMP, 'DD/MM/YYYY'),     '0') <> NVL(TO_CHAR(:NEW.DTBAIXACOMP, 'DD/MM/YYYY'),     '0')) OR
            (NVL(:OLD.CDFILIBAIXAREC,  '0') <> NVL(:NEW.CDFILIBAIXAREC,  '0')) OR
            (NVL(:OLD.NRBAIXAREC,      '0') <> NVL(:NEW.NRBAIXAREC,      '0')) OR
            (NVL(:OLD.CDFILIBAIXAPAG,  '0') <> NVL(:NEW.CDFILIBAIXAPAG,  '0')) OR
            (NVL(:OLD.NRBAIXAPAG,      '0') <> NVL(:NEW.NRBAIXAPAG,      '0')) OR
            (NVL(:OLD.IDTPITUTLCOMPAG, '0') <> NVL(:NEW.IDTPITUTLCOMPAG, '0')) OR
            (NVL(TO_CHAR(:OLD.QTITENSCOMPPAG),  '0') <> NVL(TO_CHAR(:NEW.QTITENSCOMPPAG),  '0')) OR
            (NVL(TO_CHAR(:OLD.VRTOTALCOMPPAG),  '0') <> NVL(TO_CHAR(:NEW.VRTOTALCOMPPAG),  '0')) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDEMPRESA || :OLD.NRLANCCOMPPAG;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDEMPRESA || :NEW.NRLANCCOMPPAG;
      END IF;

      IF NVL(:OLD.CDEMPRESA, '0') <> NVL(:NEW.CDEMPRESA, '0') THEN
         V_DESC := V_DESC || 'CdEmp=' || :NEW.CDEMPRESA;
      END IF;

      IF NVL(:OLD.NRLANCCOMPPAG,'0') <>  NVL(:NEW.NRLANCCOMPPAG,'0') THEN
         V_DESC := V_DESC || ' NroComp=' || :NEW.NRLANCCOMPPAG;
      END IF;

      IF (NVL(:OLD.CDFILIAL, '0') <> NVL(:NEW.CDFILIAL, '0')) OR
         (NVL(:OLD.NRLANBOLPAG,'0') <>  NVL(:NEW.NRLANBOLPAG,'0')) THEN
         V_DESC := V_DESC || ' ChaveBol=' || :NEW.CDFILIAL || :NEW.NRLANBOLPAG;
      END IF;

      IF NVL(:OLD.CDOPERLANCCOMCP,'0') <> NVL(:NEW.CDOPERLANCCOMCP, '0') THEN
         V_DESC := V_DESC || ' CdOpLanc=' || :NEW.CDOPERLANCCOMCP;
      END IF;

      IF NVL(TO_CHAR(:OLD.DTLANCCOMPPAG, 'DD/MM/YYYY'), '0') <> NVL(TO_CHAR(:NEW.DTLANCCOMPPAG, 'DD/MM/YYYY'), '0') THEN
         V_DESC := V_DESC || ' DtLancC=' || TO_CHAR(:NEW.DTLANCCOMPPAG, 'DD/MM/YYYY');
      END IF;

      IF NVL(:OLD.CDFORNECED, '0') <>  NVL(:NEW.CDFORNECED, '0') THEN
         V_DESC := V_DESC || ' CdForn=' || :NEW.CDFORNECED;
      END IF;

      IF NVL(TO_CHAR(:OLD.DTCOMPENCTPAG, 'DD/MM/YYYY') , '0') <> NVL(TO_CHAR(:NEW.DTCOMPENCTPAG, 'DD/MM/YYYY'), '0') THEN
         V_DESC := V_DESC || ' DtCompPag=' || TO_CHAR(:NEW.DTCOMPENCTPAG, 'DD/MM/YYYY');
      END IF;

      IF NVL(:OLD.CDTPBAIXAREC, '0') <> NVL(:NEW.CDTPBAIXAREC, '0') THEN
         V_DESC := V_DESC || ' TpBxRec=' || :NEW.CDTPBAIXAREC;
      END IF;

      IF NVL(:OLD.CDTPBAIXAPAG, '0') <> NVL(:NEW.CDTPBAIXAPAG, '0') THEN
         V_DESC := V_DESC || ' TpBxPag=' || :NEW.CDTPBAIXAPAG;
      END IF;

      IF NVL(:OLD.CDAJUCTREC, '0') <> NVL(:NEW.CDAJUCTREC, '0') THEN
         V_DESC := V_DESC || ' TpAjRec=' ||  :NEW.CDAJUCTREC;
      END IF;

      IF NVL(:OLD.CDAJUCTPAG, '0') <> NVL(:NEW.CDAJUCTPAG, '0') THEN
         V_DESC := V_DESC || ' TpAjPag=' ||  :NEW.CDAJUCTPAG;
      END IF;

      IF NVL(:OLD.CDREDUCONT, '0') <> NVL(:NEW.CDREDUCONT, '0') THEN
         V_DESC := V_DESC || ' CdReCont=' || :NEW.CDREDUCONT;
      END IF;

      IF NVL(TO_CHAR(:OLD.DTBAIXACOMP, 'DD/MM/YYYY'),  '0') <> NVL(TO_CHAR(:NEW.DTBAIXACOMP, 'DD/MM/YYYY'), '0') THEN
         V_DESC := V_DESC || ' DtBxComp=' || TO_CHAR(:NEW.DTBAIXACOMP, 'DD/MM/YYYY');
      END IF;

      IF (NVL(:OLD.CDFILIBAIXAREC, '0') <> NVL(:NEW.CDFILIBAIXAREC, '0')) OR
         (NVL(:OLD.NRBAIXAREC, '0') <> NVL(:NEW.NRBAIXAREC, '0')) THEN
         V_DESC := V_DESC || ' ChavBxRec=' || :NEW.CDFILIBAIXAREC || :NEW.NRBAIXAREC;
      END IF;

      IF (NVL(:OLD.CDFILIBAIXAPAG, '0') <> NVL(:NEW.CDFILIBAIXAPAG, '0')) OR
         (NVL(:OLD.NRBAIXAPAG, '0') <>  NVL(:NEW.NRBAIXAPAG, '0')) THEN
         V_DESC := V_DESC || ' ChavBxPag=' || :NEW.CDFILIBAIXAPAG || :NEW.NRBAIXAPAG;
      END IF;

      IF NVL(:OLD.IDTPITUTLCOMPAG, '0') <> NVL(:NEW.IDTPITUTLCOMPAG, '0') THEN
         V_DESC := V_DESC || ' IdItem=' || :OLD.IDTPITUTLCOMPAG;
      END IF;

      IF NVL(TO_CHAR(:OLD.QTITENSCOMPPAG), '0') <> NVL(TO_CHAR(:NEW.QTITENSCOMPPAG), '0') THEN
         V_DESC := V_DESC || ' QtItens=' || TO_CHAR(:NEW.QTITENSCOMPPAG);
      END IF;

      IF NVL(TO_CHAR(:OLD.VRTOTALCOMPPAG), '0') <> NVL(TO_CHAR(:NEW.VRTOTALCOMPPAG), '0') THEN
         V_DESC := V_DESC || ' VrComp=' || TO_CHAR(:NEW.VRTOTALCOMPPAG);
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('COMPENSACONTPAG',  V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC,V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_COMPENSACONTPAG','5.50.xxx'); END;
/

