-- =============================================================================
-- Database name :  COMISSARIA
-- Created on    :  17/07/2004  18:08
-- Programador   :  Mariana Costa
--==============================================================================
-- @C:\Win_V4\Sql\End_Conv\Oracle\1130_COCTRGO_Grava_TCOMPPRO.SQL
--==============================================================================

-- =============================================================================
--   Insere TCOMPPRO
-- =============================================================================
CREATE OR REPLACE TRIGGER Grava_TCOMPPRO
BEFORE INSERT
ON COMPPROD FOR EACH ROW
DECLARE
   V_CDFILIAL   ESPEPROD.CDFILIAL  %TYPE;
   V_CDTIPOCOMP TCOMPPRO.CDTIPOCOMP%TYPE;
   V_IDTPMANUAL ESPEPROD.IDTPMANUAL%TYPE;
   CONT         NUMBER;

BEGIN
	SELECT MAX(CDFILIAL),MAX(IDTPMANUAL)
   INTO V_CDFILIAL,V_IDTPMANUAL
   FROM ESPEPROD
   WHERE (CDPRODUTO  = :NEW.CDPRODUTO ) AND
         (CDESPEPROD = :NEW.CDESPEPROD);

   IF V_IDTPMANUAL IS NOT NULL THEN
      SELECT MAX(CDTIPOCOMP)
      INTO V_CDTIPOCOMP
      FROM PARAMCOMIS
      WHERE (CDFILIAL = V_CDFILIAL);

      IF V_CDTIPOCOMP IS NOT NULL THEN
         SELECT COUNT(*)
         INTO CONT
         FROM TCOMPPRO
         WHERE (CDPRODUTO  = :NEW.CDPRODUTO ) AND
               (CDESPEPROD = :NEW.CDESPEPROD) AND
               (CDTIPOCOMP = V_CDTIPOCOMP   );

         IF CONT = 0 THEN
            INSERT INTO TCOMPPRO
               (CDPRODUTO, CDESPEPROD, CDTIPOCOMP, QTPRODTCOMP, IDTCOMPPROC)
            VALUES
               (:NEW.CDPRODUTO, :NEW.CDESPEPROD, V_CDTIPOCOMP, 1, 'S');
         END IF;
      ELSE
			raise_application_error(-20502,'No h tipo de composio padro cadastrada para a filial '||V_CDFILIAL||'.',false);
      END IF;
   END IF;
END;
/
