IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ARQUIVOS' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
   DROP TRIGGER DTULTATU_ARQUIVOS
GO

CREATE TRIGGER DTULTATU_ARQUIVOS
ON ARQUIVOS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ARQUIVOS', '', 'CDARQUIVO='+CDARQUIVO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ARQUIVOS
         SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
        FROM INSERTED
       WHERE (ISNULL(SETORPRODINTER.CDARQUIVO,0) = ISNULL(INSERTED.CDARQUIVO,0));
   END;
END;
GO

UPDATE ARQUIVOS SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUARQUIVOS' and
            type = 'D')
   ALTER TABLE ARQUIVOS DROP CONSTRAINT DEFAULT_DTULTATUARQUIVOS
GO

ALTER TABLE ARQUIVOS ADD CONSTRAINT DEFAULT_DTULTATUARQUIVOS
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ARQUIVOS','5.85.000';
GO